<template>
  <div class="p-3">
    <div class="subheader mb-2">Select Datasets</div>
    <div class="row form-input">
      <div class="col-md-5">
        <multiselect
          v-model="value"
          :options="datasets"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          :preserve-search="true"
          placeholder="Please select the datasets"
          label="label"
          track-by="label"
          @input="addSelection()"
        >
        </multiselect>
        <span v-if="datasetErrors.selection" class="error-msg">
          {{ datasetErrors.selection }}
        </span>
      </div>
      <div class="col-2">
        <a href="/access-request/datasets" target="_blank">View metadata</a>
      </div>
    </div>
    <div class="form-input">
      <div class="subheader mb-2">Project Title</div>
      <b-form-input
        v-model="formData.project_title.value"
        data-cy="input-title-create-project"
        placeholder="Title for the project"
        class="mb-1"
      >
      </b-form-input>
      <span v-if="formData.project_title.error" class="error-msg"
        >Please fill a project title</span
      >
    </div>

    <div class="form-input">
      <div class="subheader mb-2">Project Acronym</div>
      <b-form-input
        v-model="formData.project_acronym.value"
        class="form-control"
        placeholder="Acronym of project for the project"
      >
      </b-form-input>
      <span v-if="formData.project_acronym.error" class="error-msg"
        >Please fill a project acronym</span
      >
    </div>

    <div class="form-input">
      <div class="subheader mb-2">Project Summary</div>
      <textarea
        v-model="formData.project_summary.value"
        rows="4"
        class="form-control"
        placeholder="Summary of project"
      >
      </textarea>
      <span v-if="formData.project_summary.error" class="error-msg"
        >Please fill a project summary</span
      >
    </div>
    <div class="form-input">
      <div class="subheader mb-2">Project Objectives (200 words)</div>
      <textarea
        v-model="formData.project_objectives.value"
        rows="4"
        class="form-control"
        placeholder="Project Objectives"
      >
      </textarea>
      <span v-if="formData.project_objectives.error" class="error-msg"
        >Please fill the project objectives</span
      >
    </div>

    <div class="form-input">
      <div class="subheader mb-2">Data Needed</div>
      <textarea
        v-model="formData.data_needed.value"
        rows="4"
        class="form-control"
        placeholder="Please specify the data you need from the datasets"
      >
      </textarea>
      <span v-if="formData.data_needed.error" class="error-msg"
        >Please specify the data that you need</span
      >
    </div>

    <div
      v-for="dataset in formData.selectedDatasets"
      :key="dataset.id"
      class="dataset-section card"
    >
      <h4>
        <b>{{ dataset.label }}</b> access details
      </h4>
      <table>
        <!-- <tr>
            <td>Reason for requesting access for {{ dataset.label }} dataset</td>
            <td>
              <input type="text" class="form-control"/>
            </td>
          </tr> -->
        <tr>
          <td width="250px">Access Type</td>
          <td>
            <select
              v-model="dataset.access_type"
              :dataset="dataset.label"
              :class="`form-control col-2 access-type-dropdown access-type-dropdown-${dataset.label}`"
              @change="accessTypeChanged($event, dataset)"
            >
              <option value="distant">Distant</option>
              <option value="physical">Physical</option>
            </select>
          </td>
        </tr>
        <tr v-if="dataset.access_type === 'physical'">
          <td>Host Location</td>
          <td>
            <b-form-input
              v-model="dataset.host_location"
              class="form-control col-5"
            >
            </b-form-input>
          </td>
        </tr>
        <tr v-if="dataset.access_type === 'physical'">
          <td>Preferred Visit Dates</td>
          <td>
            <b-form-input
              v-model="dataset.preferred_visit_dates"
              class="form-control col-5"
            >
            </b-form-input>
          </td>
        </tr>
        <tr>
          <td>Make this my main dataset</td>
          <td>
            <input
              :id="`is_main_${dataset.label}`"
              type="radio"
              name="is_main"
              :checked="dataset.is_main === 1"
              class="is_main_radio"
              @input="isMainChanged(dataset)"
            />
          </td>
        </tr>
      </table>
    </div>
    <span v-if="datasetErrors.main" class="error-msg">{{
      datasetErrors.main
    }}</span>

    <div class="subheader mb-2">CV</div>
    <div class="card">
      <div>
        <Dropzone
          id="dropzone"
          ref="myDropzone"
          class="upload upload-bordered h-100"
          :options="dropzoneOptions"
          :use-custom-slot="true"
          @vdropzone-file-added="onFileAdded"
          @vdropzone-error="onError"
          @vdropzone-success="onSuccess"
          @vdropzone-complete="onComplete"
          @vdropzone-removed-file="onRemoved"
        >
          <div class="upload-icon dz-clickable">
            <img
              alt="upload cv dropdown area"
              class="h-8 mt-2 mb-2"
              src="/illustrations/upload-datasets.svg"
              height="50"
            />
          </div>
          <p class="upload-subtitle text-muted dx-clickable">
            Drop file here or click to upload your CV (pdf format)
          </p>
        </Dropzone>
      </div>
    </div>
    <b-button class="submit-button" @click="submit()">Submit</b-button>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import Dropzone from 'nuxt-dropzone';
import 'nuxt-dropzone/dropzone.css';

export default {
  components: { Multiselect, Dropzone },
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      datasets: [],
      decodedToken: null,
      value: [],
      datasetErrors: {
        main: null,
        selection: null,
      },
      dropzoneOptions: {
        url: 'https://riba.risis.io',
        thumbnailWidth: 50,
        autoProcessQueue: false,
        addRemoveLinks: true,
        maxFiles: 1,
        dictDefaultMessage: 'Drop file here or click to upload your CV',
      },
      file: null,
      title: '',
      main_is_distant: false,
      formData: {
        project_title: {
          value: '',
          error: false,
        },
        project_acronym: {
          value: '',
          error: false,
        },
        project_summary: {
          value: '',
          error: false,
        },
        project_objectives: {
          value: '',
          error: false,
        },
        data_needed: {
          value: '',
          error: false,
        },
        selectedDatasets: [],
        cv_url: {
          value: '',
          error: false,
        },
      },
    };
  },
  async fetch() {
    this.datasets = await this.$nuxt.context.store.dispatch(
      'access_request/fetchDatasets'
    );
    this.datasets.forEach((dataset) => {
      dataset.access_type = 'distant';
    });
    // I have to do this for some reason?
    this.datasets = JSON.parse(JSON.stringify(this.datasets));
  },
  head() {
    return {
      title: 'Create a new Access Request - RISIS Workspace',
    };
  },
  mounted() {
    function parseJwt(token) {
      return JSON.parse(Buffer.from(token.split('.')[1], 'base64').toString());
    }
    const token = this.$auth.strategy.token.get().split(' ');
    this.decodedToken = parseJwt(token[1]);
  },
  methods: {
    async submit() {
      Object.keys(this.formData).forEach((key) => {
        if (this.formData[key].error) {
          this.formData[key].error = false;
        }
      });
      this.datasetErrors = {
        main: null,
        selection: null,
      };
      let totalErrors = 0;

      this.formData.files = [this.file];
      if (this.formData.project_title.value === '') {
        this.formData.project_title.error = true;
        totalErrors++;
      }

      if (this.formData.project_acronym.value === '') {
        this.formData.project_acronym.error = true;
        totalErrors++;
      }

      if (this.formData.project_summary.value === '') {
        this.formData.project_summary.error = true;
        totalErrors++;
      }

      if (this.formData.project_objectives.value === '') {
        this.formData.project_objectives.error = true;
        totalErrors++;
      }

      if (this.formData.data_needed.value === '') {
        this.formData.data_needed.error = true;
        totalErrors++;
      }

      if (this.formData.selectedDatasets.length === 0) {
        totalErrors++;
        this.datasetErrors.selection = 'Please select at least one dataset';
      }
      if (
        !this.formData.selectedDatasets.find((dataset) => dataset.is_main === 1)
      ) {
        totalErrors++;
        this.datasetErrors.main = 'Please select one dataset as main';
      }

      if (totalErrors === 0) {
        const formData = {};
        Object.keys(this.formData).forEach((key) => {
          formData[key] = this.formData[key].value;
        });
        formData.selectedDatasets = this.formData.selectedDatasets;
        try {
          const res = await this.$nuxt.context.store.dispatch(
            'access_request/createAccessRequest',
            formData
          );
          if (res) {
            if (this.file) {
              await this.$nuxt.context.store.dispatch(
                'access_request/submitCv',
                {
                  id: res.id,
                  file: this.file,
                }
              );
            }
            window.location = `/access-request/${res.id}/details`;
          }
        } catch (e) {
          await this.$bvModal.msgBoxConfirm(
            'There was an error submitting the access request, please try again'
          );
        }
      }
    },
    delay(time) {
      return new Promise((resolve) => setTimeout(resolve, time));
    },
    addSelection() {
      this.formData.selectedDatasets = this.value;
      this.updateAccessType();
    },
    isMainChanged(dataset) {
      this.formData.selectedDatasets.map((d) => (d.is_main = 0));
      dataset.is_main = 1;
      // make secondary datasets distant in cases when main dataset is distant
      if (dataset.access_type === 'distant') {
        this.formData.selectedDatasets.map((d) => (d.access_type = 'distant'));
      }
      this.updateAccessType();
    },
    async accessTypeChanged(event, dataset) {
      dataset.access_type = event.target.value;
      await this.delay(500);
      this.updateAccessType();
    },
    updateAccessType() {
      const inputs = document.getElementsByClassName('access-type-dropdown');
      const mainDataset = this.formData.selectedDatasets.find(
        (d) => d.is_main === 1
      );
      if (!mainDataset) {
        return;
      }

      if (mainDataset.access_type === 'distant') {
        this.formData.selectedDatasets.map((d) => (d.access_type = 'distant'));
        for (let i = 0; i < inputs.length; i++) {
          const datasetName = inputs[i].getAttribute('dataset');
          if (datasetName !== mainDataset.label) {
            inputs[i].setAttribute('disabled', 'disabled');
          } else {
            inputs[i].removeAttribute('disabled');
          }
        }
      } else {
        for (let i = 0; i < inputs.length; i++) {
          inputs[i].removeAttribute('disabled');
        }
      }
    },
    onFileAdded(e) {
      this.file = e;
      if (!this.title) {
        if (e.name.includes('.')) {
          this.title = e.name.split('.').slice(0, -1).join('.');
        } else {
          this.title = e.name;
        }
      }
    },
    onError() {},
    onSuccess() {},
    onComplete() {},
    onRemoved() {
      this.file = null;
      this.title = null;
    },
  },
};
</script>

<style scoped>
.dataset-section {
  margin: 5px 0 5px 0;
  border: 1px solid lightgray;
  border-radius: 2px;
  padding: 10px;
}

.submit-button {
  margin-top: 10px;
  float: right;
}

.datasets-dropdown-container {
  width: 40% !important;
}

.error-msg {
  color: rgb(235, 64, 64);
}

.form-input {
  margin-bottom: 20px;
}

.info {
  padding: 10px;
  margin-bottom: 20px;
  border: 1px solid lightgray;
  border-radius: 2px;
}
</style>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>
